Loading...
Searching...
No Matches
construction.h File Reference

Functions for constructing nuclear reaction networks. More...

`#include "gridfire/reaction/reaction.h"`
`#include "gridfire/engine/types/building.h"`
`#include "fourdst/composition/composition_abstract.h"`
`#include <variant>`
`#include "gridfire/reaction/weak/weak_interpolator.h"`
Include dependency graph for construction.h:
This graph shows which files directly or indirectly include this file:

## Namespaces

namespace | gridfire
namespace | gridfire::engine

## Enumerations

enum class

gridfire::engine::NetworkConstructionFlags : uint32_t {
gridfire::engine::NONE = 0 , gridfire::engine::REACLIB_STRONG = 1 << 0 , gridfire::engine::WRL_BETA_MINUS = 1 << 1 , gridfire::engine::WRL_BETA_PLUS = 1 << 2 ,
gridfire::engine::WRL_ELECTRON_CAPTURE = 1 << 3 , gridfire::engine::WRL_POSITRON_CAPTURE = 1 << 4 , gridfire::engine::REACLIB_WEAK = 1 << 5 , gridfire::engine::WRL_WEAK = WRL_BETA_MINUS | WRL_BETA_PLUS | WRL_ELECTRON_CAPTURE | WRL_POSITRON_CAPTURE ,
gridfire::engine::REACLIB = REACLIB_STRONG | REACLIB_WEAK , gridfire::engine::DEFAULT = REACLIB
}

| Flags to specify which types of nuclear reactions to include when constructing a reaction network. More...

## Functions

constexpr auto | gridfire::engine::to_underlying (NetworkConstructionFlags f) noexcept
| Helper function to convert NetworkConstructionFlags to their underlying integer type.
NetworkConstructionFlags | gridfire::engine::operator| (const NetworkConstructionFlags lhs, const NetworkConstructionFlags rhs)
| Bitwise OR operator for NetworkConstructionFlags.
NetworkConstructionFlags | gridfire::engine::operator& (const NetworkConstructionFlags lhs, const NetworkConstructionFlags rhs)
| Bitwise AND operator for NetworkConstructionFlags.
bool | gridfire::engine::has_flag (const NetworkConstructionFlags flags, const NetworkConstructionFlags flag_to_check)
| Checks if a specific flag is set within a NetworkConstructionFlags value.
std::string | gridfire::engine::NetworkConstructionFlagsToString (NetworkConstructionFlags flags)
| Converts NetworkConstructionFlags to a human-readable string.
reaction::ReactionSet | gridfire::engine::build_nuclear_network (const fourdst::composition::CompositionAbstract &composition, const rates::weak::WeakRateInterpolator &weakInterpolator, BuildDepthType maxLayers=NetworkBuildDepth::Full, NetworkConstructionFlags ReactionTypes=NetworkConstructionFlags::DEFAULT)
| Builds a nuclear reaction network from the Reaclib library based on an initial composition.

## Detailed Description

Functions for constructing nuclear reaction networks.